Merge pull request #31271 from thaJeztah/cherry-pick-changelog-validation

[17.03] Cherry pick changelog validation
This commit is contained in:
Victor Vieux 2017-02-22 19:38:05 -08:00 committed by GitHub
commit 455ebb8892
4 changed files with 40 additions and 1 deletions

View file

@ -1473,7 +1473,7 @@ that allows to add build-time environment variables (#15182)
- devicemapper: Implement deferred deletion capability (#16381)
## Networking
### Networking
+ `docker network` exits experimental and is part of standard release (#16645)
+ New network top-level concept, with associated subcommands and API (#16645)

View file

@ -0,0 +1,12 @@
#!/bin/bash
changelogFile=${1:-CHANGELOG.md}
if [ ! -r "$changelogFile" ]; then
echo "Unable to read file $changelogFile" >&2
exit 1
fi
grep -e '^## ' "$changelogFile" | awk '{print$3}' | sort -c -r || exit 2
echo "Congratulations! Changelog $changelogFile dates are in descending order."

View file

@ -0,0 +1,25 @@
#!/bin/bash
changelogFile=${1:-CHANGELOG.md}
if [ ! -r "$changelogFile" ]; then
echo "Unable to read file $changelogFile" >&2
exit 1
fi
changelogWellFormed=1
# e.g. "## 1.12.3 (2016-10-26)"
VER_LINE_REGEX='^## [0-9]+\.[0-9]+\.[0-9]+(-ce)? \([0-9]+-[0-9]+-[0-9]+\)$'
while read -r line; do
if ! [[ "$line" =~ $VER_LINE_REGEX ]]; then
echo "Malformed changelog $changelogFile line \"$line\"" >&2
changelogWellFormed=0
fi
done < <(grep '^## ' $changelogFile)
if [[ "$changelogWellFormed" == "1" ]]; then
echo "Congratulations! Changelog $changelogFile is well-formed."
else
exit 2
fi

View file

@ -14,3 +14,5 @@ export SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
. $SCRIPTDIR/test-imports
. $SCRIPTDIR/toml
. $SCRIPTDIR/vet
. $SCRIPTDIR/changelog-well-formed
. $SCRIPTDIR/changelog-date-descending